package cofh.thermal.expansion.block.entity.dynamo;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.lib.api.StorageGroup;
import cofh.lib.inventory.ItemStorageCoFH;
import cofh.thermal.core.config.ThermalCoreConfig;
import cofh.thermal.core.util.managers.dynamo.DisenchantmentFuelManager;
import cofh.thermal.expansion.init.TExpTileEntities;
import cofh.thermal.expansion.inventory.container.dynamo.DynamoDisenchantmentContainer;
import cofh.thermal.lib.block.entity.DynamoBlockEntity;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;

public class DynamoDisenchantmentTile extends DynamoBlockEntity {
  protected ItemStorageCoFH fuelSlot;
  
  public DynamoDisenchantmentTile(BlockPos pos, BlockState state) {
    super((BlockEntityType)TExpTileEntities.DYNAMO_DISENCHANTMENT_TILE.get(), pos, state);
    this.fuelSlot = new ItemStorageCoFH(item -> (this.filter.valid(item) && DisenchantmentFuelManager.instance().validFuel(item)));
    this.inventory.addSlot(this.fuelSlot, StorageGroup.INPUT);
    addAugmentSlots(ThermalCoreConfig.dynamoAugments);
    initHandlers();
  }
  
  protected int getBaseProcessTick() {
    return DisenchantmentFuelManager.instance().getBasePower();
  }
  
  protected boolean canProcessStart() {
    return (DisenchantmentFuelManager.instance().getEnergy(this.fuelSlot.getItemStack()) > 0);
  }
  
  protected void processStart() {
    this.fuel += this.fuelMax = Math.round(DisenchantmentFuelManager.instance().getEnergy(this.fuelSlot.getItemStack()) * this.energyMod);
    this.fuelSlot.consume(1);
  }
  
  @Nullable
  public AbstractContainerMenu m_7208_(int i, Inventory inventory, Player player) {
    return (AbstractContainerMenu)new DynamoDisenchantmentContainer(i, this.f_58857_, this.f_58858_, inventory, player);
  }
}
